<center><a href="ilut.c">Actual source code: ilut.c</a></center><br>

<html>
<head>
<title></title>
<meta name="generator" content="c2html 0.9.5">
<meta name="date" content="2007-03-29T00:22:34+00:00">
</head>

<body bgcolor="#FFFFFF">
<pre width="80"><a name="line1">  1: </a><strong><font color="#228B22">#define PETSCMAT_DLL</font></strong>

<a name="line3"> 3: </a> #include <A href="../../../../../include/petsc.h.html">petsc.h</A>
<a name="line4">  4: </a><font color="#A020F0">#if !defined(PETSC_AVOID_GNUCOPYRIGHT_CODE)</font>

<a name="line6">  6: </a><font color="#B22222">/* ilut.f -- translated by f2c (version of 25 March 1992  12:58:56).</font>

<a name="line8">  8: </a><font color="#B22222">     The Fortran version of this code was developed by Yousef Saad.</font>
<a name="line9">  9: </a><font color="#B22222">  This code is copyrighted by Yousef Saad with the </font>

<a name="line11"> 11: </a><font color="#B22222">                    GNU GENERAL PUBLIC LICENSE</font>
<a name="line12"> 12: </a><font color="#B22222">                       Version 2, June 1991</font>

<a name="line14"> 14: </a><font color="#B22222"> Copyright (C) 1989, 1991 Free Software Foundation, Inc.</font>
<a name="line15"> 15: </a><font color="#B22222">                          675 Mass Ave, Cambridge, MA 02139, USA</font>
<a name="line16"> 16: </a><font color="#B22222"> Everyone is permitted to copy and distribute verbatim copies</font>
<a name="line17"> 17: </a><font color="#B22222"> of this license document, but changing it is not allowed.</font>

<a name="line19"> 19: </a><font color="#B22222">                            Preamble</font>

<a name="line21"> 21: </a><font color="#B22222">  The licenses for most software are designed to take away your</font>
<a name="line22"> 22: </a><font color="#B22222">freedom to share and change it.  By contrast, the GNU General Public</font>
<a name="line23"> 23: </a><font color="#B22222">License is intended to guarantee your freedom to share and change free</font>
<a name="line24"> 24: </a><font color="#B22222">software--to make sure the software is free for all its users.  This</font>
<a name="line25"> 25: </a><font color="#B22222">General Public License applies to most of the Free Software</font>
<a name="line26"> 26: </a><font color="#B22222">Foundation's software and to any other program whose authors commit to</font>
<a name="line27"> 27: </a><font color="#B22222">using it.  (Some other Free Software Foundation software is covered by</font>
<a name="line28"> 28: </a><font color="#B22222">the GNU Library General Public License instead.)  You can apply it to</font>
<a name="line29"> 29: </a><font color="#B22222">your programs, too.</font>

<a name="line31"> 31: </a><font color="#B22222">  When we speak of free software, we are referring to freedom, not</font>
<a name="line32"> 32: </a><font color="#B22222">price.  Our General Public Licenses are designed to make sure that you</font>
<a name="line33"> 33: </a><font color="#B22222"><strong></font><font color="#4169E1"><a name="software"></a>have the freedom to distribute copies of free software (and charge for</font></strong>
<a name="line34"> 34: </a><strong><font color="#4169E1">this service if you wish)</font></strong>, that you receive source code or can get it
<a name="line35"> 35: </a>if you want it, that you can change the software or use pieces of it
<a name="line36"> 36: </a>in new free programs; and that you know you can do these things.

<a name="line38"> 38: </a>  To protect your rights, we need to make restrictions that forbid
<a name="line39"> 39: </a>anyone to deny you these rights or to ask you to surrender the rights.
<a name="line40"> 40: </a>These restrictions translate to certain responsibilities for you if you
<a name="line41"> 41: </a>distribute copies of the software, or if you modify it.

<a name="line43"> 43: </a>  For example, if you distribute copies of such a program, whether
<a name="line44"> 44: </a>gratis or for a fee, you must give the recipients all the rights that
<a name="line45"> 45: </a>you have.  You must make sure that they, too, receive or can get the
<a name="line46"> 46: </a>source code.  And you must show them these terms so they know their
<a name="line47"> 47: </a>rights.

<a name="line49"> 49: </a>  We protect your rights with two steps: (1) copyright the software, and
<a name="line50"> 50: </a>(2) offer you this license which gives you legal permission to copy,
<a name="line51"> 51: </a>distribute and/or modify the software.

<a name="line53"> 53: </a>  Also, for each author's protection and ours, we want to make certain
<a name="line54"> 54: </a>that everyone understands that there is no warranty for this free
<a name="line55"> 55: </a>software.  If the software is modified by someone else and passed on, we
<a name="line56"> 56: </a>want its recipients to know that what they have is not the original, so
<a name="line57"> 57: </a>that any problems introduced by others will not reflect on the original
<a name="line58"> 58: </a>authors' reputations.

<a name="line60"> 60: </a>  Finally, any free program is threatened constantly by software
<a name="line61"> 61: </a>patents.  We wish to avoid the danger that redistributors of a free
<a name="line62"> 62: </a>program will individually obtain patent licenses, in effect making the
<a name="line63"> 63: </a>program proprietary.  To prevent this, we have made it clear that any
<a name="line64"> 64: </a>patent must be licensed for everyone's free use or not licensed at all.

<a name="line66"> 66: </a>  The precise terms and conditions for copying, distribution and
<a name="line67"> 67: </a>modification follow.
<a name="line68"> 68: </a> 
<a name="line69"> 69: </a>                    GNU GENERAL PUBLIC LICENSE
<a name="line70"> 70: </a>   TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION

<a name="line72"> 72: </a>  0. This License applies to any program or other work which contains
<a name="line73"> 73: </a>a notice placed by the copyright holder saying it may be distributed
<a name="line74"> 74: </a>under the terms of this General Public License.  The "Program", below,
<a name="line75"> 75: </a>refers to any such program or work, and a "work based on the Program"
<a name="line76"> 76: </a>means either the Program or any derivative work under copyright law:
<a name="line77"> 77: </a>that is to say, a work containing the Program or a portion of it,
<a name="line78"> 78: </a>either verbatim or with modifications and/or translated into another
<a name="line79"> 79: </a>language.  (Hereinafter, translation is included without limitation in
<a name="line80"> 80: </a>the term "modification".)  Each licensee is addressed as "you".

<a name="line82"> 82: </a>Activities other than copying, distribution and modification are not
<a name="line83"> 83: </a>covered by this License; they are outside its scope.  The act of
<a name="line84"> 84: </a>running the Program is not restricted, and the output from the Program
<a name="line85"> 85: </a><strong><font color="#4169E1"><a name="Program"></a>is covered only if its contents constitute a work based on the</font></strong>
<a name="line86"> 86: </a><strong><font color="#4169E1">Program (independent of having been made by running the Program)</font></strong>.
<a name="line87"> 87: </a>Whether that is true depends on what the Program does.

<a name="line89"> 89: </a>  1. You may copy and distribute verbatim copies of the Program's
<a name="line90"> 90: </a>source code as you receive it, in any medium, provided that you
<a name="line91"> 91: </a>conspicuously and appropriately publish on each copy an appropriate
<a name="line92"> 92: </a>copyright notice and disclaimer of warranty; keep intact all the
<a name="line93"> 93: </a>notices that refer to this License and to the absence of any warranty;
<a name="line94"> 94: </a>and give any other recipients of the Program a copy of this License
<a name="line95"> 95: </a>along with the Program.

<a name="line97"> 97: </a>You may charge a fee for the physical act of transferring a copy, and
<a name="line98"> 98: </a>you may at your option offer warranty protection in exchange for a fee.

<a name="line100">100: </a>  2. You may modify your copy or copies of the Program or any portion
<a name="line101">101: </a>of it, thus forming a work based on the Program, and copy and
<a name="line102">102: </a>distribute such modifications or work under the terms of Section 1
<a name="line103">103: </a>above, provided that you also meet all of these conditions:

<a name="line105">105: </a>    a) You must cause the modified files to carry prominent notices
<a name="line106">106: </a>    stating that you changed the files and the date of any change.

<a name="line108">108: </a>    b) You must cause any work that you distribute or publish, that in
<a name="line109">109: </a>    whole or in part contains or is derived from the Program or any
<a name="line110">110: </a>    part thereof, to be licensed as a whole at no charge to all third
<a name="line111">111: </a>    parties under the terms of this License.

<a name="line113">113: </a>    c) If the modified program normally reads commands interactively
<a name="line114">114: </a>    when run, you must cause it, when started running for such
<a name="line115">115: </a>    interactive use in the most ordinary way, to print or display an
<a name="line116">116: </a>    announcement including an appropriate copyright notice and a
<a name="line117">117: </a>    notice that there is no warranty (or else, saying that you provide
<a name="line118">118: </a>    a warranty) and that users may redistribute the program under
<a name="line119">119: </a>    these conditions, and telling the user how to view a copy of this
<a name="line120">120: </a>    License.  (Exception: if the Program itself is interactive but
<a name="line121">121: </a>    does not normally print such an announcement, your work based on
<a name="line122">122: </a>    the Program is not required to print an announcement.)
<a name="line123">123: </a> 
<a name="line124">124: </a>These requirements apply to the modified work as a whole.  If
<a name="line125">125: </a>identifiable sections of that work are not derived from the Program,
<a name="line126">126: </a>and can be reasonably considered independent and separate works in
<a name="line127">127: </a>themselves, then this License, and its terms, do not apply to those
<a name="line128">128: </a>sections when you distribute them as separate works.  But when you
<a name="line129">129: </a>distribute the same sections as part of a whole which is a work based
<a name="line130">130: </a>on the Program, the distribution of the whole must be on the terms of
<a name="line131">131: </a>this License, whose permissions for other licensees extend to the
<a name="line132">132: </a>entire whole, and thus to each and every part regardless of who wrote it.

<a name="line134">134: </a>Thus, it is not the intent of this section to claim rights or contest
<a name="line135">135: </a>your rights to work written entirely by you; rather, the intent is to
<a name="line136">136: </a>exercise the right to control the distribution of derivative or
<a name="line137">137: </a>collective works based on the Program.

<a name="line139">139: </a>In addition, mere aggregation of another work not based on the Program
<a name="line140">140: </a>with the Program (or with a work based on the Program) on a volume of
<a name="line141">141: </a>a storage or distribution medium does not bring the other work under
<a name="line142">142: </a>the scope of this License.

<a name="line144">144: </a>  3. You may copy and distribute the Program (or a work based on it,
<a name="line145">145: </a>under Section 2) in object code or executable form under the terms of
<a name="line146">146: </a>Sections 1 and 2 above provided that you also do one of the following:

<a name="line148">148: </a>    a) Accompany it with the complete corresponding machine-readable
<a name="line149">149: </a>    source code, which must be distributed under the terms of Sections
<a name="line150">150: </a>    1 and 2 above on a medium customarily used for software interchange; or,

<a name="line152">152: </a>    b) Accompany it with a written offer, valid for at least three
<a name="line153">153: </a>    years, to give any third party, for a charge no more than your
<a name="line154">154: </a>    cost of physically performing source distribution, a complete
<a name="line155">155: </a>    machine-readable copy of the corresponding source code, to be
<a name="line156">156: </a>    distributed under the terms of Sections 1 and 2 above on a medium
<a name="line157">157: </a>    customarily used for software interchange; or,

<a name="line159">159: </a>    c) Accompany it with the information you received as to the offer
<a name="line160">160: </a>    to distribute corresponding source code.  (This alternative is
<a name="line161">161: </a>    allowed only for noncommercial distribution and only if you
<a name="line162">162: </a>    received the program in object code or executable form with such
<a name="line163">163: </a>    an offer, in accord with Subsection b above.)

<a name="line165">165: </a>The source code for a work means the preferred form of the work for
<a name="line166">166: </a>making modifications to it.  For an executable work, complete source
<a name="line167">167: </a>code means all the source code for all modules it contains, plus any
<a name="line168">168: </a>associated interface definition files, plus the scripts used to
<a name="line169">169: </a>control compilation and installation of the executable.  However, as a
<a name="line170">170: </a>special exception, the source code distributed need not include
<a name="line171">171: </a><strong><font color="#4169E1"><a name="distributed"></a>anything that is normally distributed (in either source or binary</font></strong>
<a name="line172">172: </a><strong><font color="#4169E1">form) with the major components (compiler, kernel, and so on)</font></strong> of the
<a name="line173">173: </a>operating system on which the executable runs, unless that component
<a name="line174">174: </a>itself accompanies the executable.

<a name="line176">176: </a>If distribution of executable or object code is made by offering
<a name="line177">177: </a>access to copy from a designated place, then offering equivalent
<a name="line178">178: </a>access to copy the source code from the same place counts as
<a name="line179">179: </a>distribution of the source code, even though third parties are not
<a name="line180">180: </a>compelled to copy the source along with the object code.
<a name="line181">181: </a> 
<a name="line182">182: </a>  4. You may not copy, modify, sublicense, or distribute the Program
<a name="line183">183: </a>except as expressly provided under this License.  Any attempt
<a name="line184">184: </a>otherwise to copy, modify, sublicense or distribute the Program is
<a name="line185">185: </a>void, and will automatically terminate your rights under this License.
<a name="line186">186: </a>However, parties who have received copies, or rights, from you under
<a name="line187">187: </a>this License will not have their licenses terminated so long as such
<a name="line188">188: </a>parties remain in full compliance.

<a name="line190">190: </a>  5. You are not required to accept this License, since you have not
<a name="line191">191: </a>signed it.  However, nothing else grants you permission to modify or
<a name="line192">192: </a>distribute the Program or its derivative works.  These actions are
<a name="line193">193: </a>prohibited by law if you do not accept this License.  Therefore, by
<a name="line194">194: </a><strong><font color="#4169E1"><a name="Program"></a>modifying or distributing the Program (or any work based on the</font></strong>
<a name="line195">195: </a><strong><font color="#4169E1">Program)</font></strong>, you indicate your acceptance of this License to do so, and
<a name="line196">196: </a>all its terms and conditions for copying, distributing or modifying
<a name="line197">197: </a>the Program or works based on it.

<a name="line199">199: </a>  6. Each time you redistribute the Program (or any work based on the
<a name="line200">200: </a>Program), the recipient automatically receives a license from the
<a name="line201">201: </a>original licensor to copy, distribute or modify the Program subject to
<a name="line202">202: </a>these terms and conditions.  You may not impose any further
<a name="line203">203: </a>restrictions on the recipients' exercise of the rights granted herein.
<a name="line204">204: </a>You are not responsible for enforcing compliance by third parties to
<a name="line205">205: </a>this License.

<a name="line207">207: </a>  7. If, as a consequence of a court judgment or allegation of patent
<a name="line208">208: </a><strong><font color="#4169E1"><a name="reason"></a>infringement or for any other reason (not limited to patent issues),</font></strong>
<a name="line209">209: </a><strong><font color="#4169E1">conditions are imposed on you (whether by court order, agreement or</font></strong>
<a name="line210">210: </a><strong><font color="#4169E1">otherwise)</font></strong> that contradict the conditions of this License, they do not
<a name="line211">211: </a>excuse you from the conditions of this License.  If you cannot
<a name="line212">212: </a>distribute so as to satisfy simultaneously your obligations under this
<a name="line213">213: </a>License and any other pertinent obligations, then as a consequence you
<a name="line214">214: </a>may not distribute the Program at all.  For example, if a patent
<a name="line215">215: </a>license would not permit royalty-free redistribution of the Program by
<a name="line216">216: </a>all those who receive copies directly or indirectly through you, then
<a name="line217">217: </a>the only way you could satisfy both it and this License would be to
<a name="line218">218: </a>refrain entirely from distribution of the Program.

<a name="line220">220: </a>If any portion of this section is held invalid or unenforceable under
<a name="line221">221: </a>any particular circumstance, the balance of the section is intended to
<a name="line222">222: </a>apply and the section as a whole is intended to apply in other
<a name="line223">223: </a>circumstances.

<a name="line225">225: </a>It is not the purpose of this section to induce you to infringe any
<a name="line226">226: </a>patents or other property right claims or to contest validity of any
<a name="line227">227: </a>such claims; this section has the sole purpose of protecting the
<a name="line228">228: </a>integrity of the free software distribution system, which is
<a name="line229">229: </a>implemented by public license practices.  Many people have made
<a name="line230">230: </a>generous contributions to the wide range of software distributed
<a name="line231">231: </a>through that system in reliance on consistent application of that
<a name="line232">232: </a>system; it is up to the author/donor to decide if he or she is willing
<a name="line233">233: </a>to distribute software through any other system and a licensee cannot
<a name="line234">234: </a>impose that choice.

<a name="line236">236: </a>This section is intended to make thoroughly clear what is believed to
<a name="line237">237: </a>be a consequence of the rest of this License.
<a name="line238">238: </a> 
<a name="line239">239: </a>  8. If the distribution and/or use of the Program is restricted in
<a name="line240">240: </a>certain countries either by patents or by copyrighted interfaces, the
<a name="line241">241: </a>original copyright holder who places the Program under this License
<a name="line242">242: </a>may add an explicit geographical distribution limitation excluding
<a name="line243">243: </a>those countries, so that distribution is permitted only in or among
<a name="line244">244: </a>countries not thus excluded.  In such case, this License incorporates
<a name="line245">245: </a>the limitation as if written in the body of this License.

<a name="line247">247: </a>  9. The Free Software Foundation may publish revised and/or new versions
<a name="line248">248: </a>of the General Public License from time to time.  Such new versions will
<a name="line249">249: </a>be similar in spirit to the present version, but may differ in detail to
<a name="line250">250: </a>address new problems or concerns.

<a name="line252">252: </a>Each version is given a distinguishing version number.  If the Program
<a name="line253">253: </a>specifies a version number of this License which applies to it and "any
<a name="line254">254: </a>later version", you have the option of following the terms and conditions
<a name="line255">255: </a>either of that version or of any later version published by the Free
<a name="line256">256: </a>Software Foundation.  If the Program does not specify a version number of
<a name="line257">257: </a>this License, you may choose any version ever published by the Free Software
<a name="line258">258: </a>Foundation.

<a name="line260">260: </a>  10. If you wish to incorporate parts of the Program into other free
<a name="line261">261: </a>programs whose distribution conditions are different, write to the author
<a name="line262">262: </a>to ask for permission.  For software which is copyrighted by the Free
<a name="line263">263: </a>Software Foundation, write to the Free Software Foundation; we sometimes
<a name="line264">264: </a>make exceptions for this.  Our decision will be guided by the two goals
<a name="line265">265: </a>of preserving the free status of all derivatives of our free software and
<a name="line266">266: </a>of promoting the sharing and reuse of software generally.

<a name="line268">268: </a>                            NO WARRANTY

<a name="line270">270: </a>  11. BECAUSE THE PROGRAM <A href="../../../../../docs/manualpages/IS/IS.html#IS">IS</A> LICENSED FREE OF CHARGE, THERE <A href="../../../../../docs/manualpages/IS/IS.html#IS">IS</A> NO WARRANTY
<a name="line271">271: </a>FOR THE PROGRAM, TO THE EXTENT PERMITTED BY APPLICABLE LAW.  EXCEPT WHEN
<a name="line272">272: </a>OTHERWISE STATED IN WRITING THE COPYRIGHT HOLDERS AND/OR OTHER PARTIES
<a name="line273">273: </a>PROVIDE THE PROGRAM "AS <A href="../../../../../docs/manualpages/IS/IS.html#IS">IS</A>" WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED
<a name="line274">274: </a>OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
<a name="line275">275: </a>MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.  THE ENTIRE RISK AS
<a name="line276">276: </a>TO THE QUALITY AND PERFORMANCE OF THE PROGRAM <A href="../../../../../docs/manualpages/IS/IS.html#IS">IS</A> WITH YOU.  SHOULD THE
<a name="line277">277: </a>PROGRAM PROVE DEFECTIVE, YOU ASSUME THE COST OF ALL NECESSARY SERVICING,
<a name="line278">278: </a>REPAIR OR CORRECTION.

<a name="line280">280: </a>  12. IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN WRITING
<a name="line281">281: </a>WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MAY MODIFY AND/OR
<a name="line282">282: </a>REDISTRIBUTE THE PROGRAM AS PERMITTED ABOVE, BE LIABLE TO YOU FOR DAMAGES,
<a name="line283">283: </a>INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING
<a name="line284">284: </a><strong><font color="#4169E1"><a name="PROGRAM"></a>OUT OF THE USE OR INABILITY TO USE THE PROGRAM (INCLUDING BUT NOT LIMITED</font></strong>
<a name="line285">285: </a><strong><font color="#4169E1">TO LOSS OF DATA OR DATA BEING RENDERED INACCURATE OR LOSSES SUSTAINED BY</font></strong>
<a name="line286">286: </a><strong><font color="#4169E1">YOU OR THIRD PARTIES OR A FAILURE OF THE PROGRAM TO OPERATE WITH ANY OTHER</font></strong>
<a name="line287">287: </a><strong><font color="#4169E1">PROGRAMS)</font></strong>, EVEN IF SUCH HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE
<a name="line288">288: </a>POSSIBILITY OF SUCH DAMAGES.

<a name="line290">290: </a>                     END OF TERMS AND CONDITIONS
<a name="line291">291: </a> 
<a name="line292">292: </a>        Appendix: How to Apply These Terms to Your New Programs

<a name="line294">294: </a>  If you develop a new program, and you want it to be of the greatest
<a name="line295">295: </a>possible use to the public, the best way to achieve this is to make it
<a name="line296">296: </a>free software which everyone can redistribute and change under these terms.

<a name="line298">298: </a>  To do so, attach the following notices to the program.  It is safest
<a name="line299">299: </a>to attach them to the start of each source file to most effectively
<a name="line300">300: </a>convey the exclusion of warranty; and each file should have at least
<a name="line301">301: </a>the "copyright" line and a pointer to where the full notice is found.

<a name="line303">303: </a>    &lt;one line to give the program's name and a brief idea of what it does.&gt;
<a name="line304">304: </a>    Copyright (C) 19yy  &lt;name of author&gt;

<a name="line306">306: </a>    This program is free software; you can redistribute it and/or modify
<a name="line307">307: </a>    it under the terms of the GNU General Public License as published by
<a name="line308">308: </a>    the Free Software Foundation; either version 2 of the License, or
<a name="line309">309: </a>    (at your option) any later version.

<a name="line311">311: </a>    This program is distributed in the hope that it will be useful,
<a name="line312">312: </a>    but WITHOUT ANY WARRANTY; without even the implied warranty of
<a name="line313">313: </a>    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
<a name="line314">314: </a>    GNU General Public License for more details.

<a name="line316">316: </a>    You should have received a copy of the GNU General Public License
<a name="line317">317: </a>    along with this program; if not, write to the Free Software
<a name="line318">318: </a>    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

<a name="line320">320: </a>Also add information on how to contact you by electronic and paper mail.

<a name="line322">322: </a>If the program is interactive, make it output a short notice like this
<a name="line323">323: </a>when it starts in an interactive mode:

<a name="line325">325: </a>    Gnomovision version 69, Copyright (C) 19yy name of author
<a name="line326">326: </a>    Gnomovision comes with ABSOLUTELY NO WARRANTY; for details type `show w'.
<a name="line327">327: </a>    This is free software, and you are welcome to redistribute it
<a name="line328">328: </a>    under certain conditions; type `show c' for details.

<a name="line330">330: </a>The hypothetical commands `show w' and `show c' should show the appropriate
<a name="line331">331: </a>parts of the General Public License.  Of course, the commands you use may
<a name="line332">332: </a>be called something other than `show w' and `show c'; they could even be
<a name="line333">333: </a>mouse-clicks or menu items--whatever suits your program.

<a name="line335">335: </a>You should also get your employer (if you work as a programmer) or your
<a name="line336">336: </a>school, if any, to sign a "copyright disclaimer" for the program, if
<a name="line337">337: </a>necessary.  Here is a sample; alter the names:

<a name="line339">339: </a>  Yoyodyne, Inc., hereby disclaims all copyright interest in the program
<a name="line340">340: </a>  `Gnomovision' (which makes passes at compilers) written by James Hacker.

<a name="line342">342: </a>  &lt;signature of Ty Coon&gt;, 1 April 1989
<a name="line343">343: </a>  Ty Coon, President of Vice

<a name="line345">345: </a>This General Public License does not permit incorporating your program into
<a name="line346">346: </a>proprietary programs.  If your program is a subroutine library, you may
<a name="line347">347: </a>consider it more useful to permit linking proprietary applications with the
<a name="line348">348: </a>library.  If this is what you want to do, use the GNU Library General
<a name="line349">349: </a>Public License instead of this License.

<a name="line351">351: </a>*/

<a name="line353">353: </a><strong><font color="#4169E1"><a name="SPARSEKIT2qsplit"></a>static <A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> SPARSEKIT2qsplit(<A href="../../../../../docs/manualpages/Sys/PetscScalar.html#PetscScalar">PetscScalar</A> *a,<A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A> *ind,<A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A> *n,<A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A> *ncut)</font></strong>
<a name="line354">354: </a>{
<a name="line355">355: </a>    <font color="#B22222">/* System generated locals */</font>
<a name="line356">356: </a>    <A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A> i__1;
<a name="line357">357: </a>    <A href="../../../../../docs/manualpages/Sys/PetscScalar.html#PetscScalar">PetscScalar</A> d__1;

<a name="line359">359: </a>    <font color="#B22222">/* Local variables */</font>
<a name="line360">360: </a>    <A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A> last,itmp,j,first;
<a name="line361">361: </a>    <A href="../../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A> abskey;
<a name="line362">362: </a>    <A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A> mid;
<a name="line363">363: </a>    <A href="../../../../../docs/manualpages/Sys/PetscScalar.html#PetscScalar">PetscScalar</A> tmp;

<a name="line365">365: </a><font color="#B22222">/* -----------------------------------------------------------------------</font>
<a name="line366">366: </a><font color="#B22222"> */</font>
<a name="line367">367: </a><font color="#B22222">/*     does a quick-sort split of a real array. */</font>
<a name="line368">368: </a><font color="#B22222">/*     on input a(1:n). is a real array */</font>
<a name="line369">369: </a><font color="#B22222">/*     on output a(1:n) is permuted such that its elements satisfy: */</font>

<a name="line371">371: </a><font color="#B22222">/*     abs(a(i)) .ge. abs(a(ncut)) for i .lt. ncut and */</font>
<a name="line372">372: </a><font color="#B22222">/*     abs(a(i)) .le. abs(a(ncut)) for i .gt. ncut */</font>

<a name="line374">374: </a><font color="#B22222">/*    ind(1:n) is an integer array which permuted in the same way as a(*).</font>
<a name="line375">375: </a><font color="#B22222">*/</font>
<a name="line376">376: </a><font color="#B22222">/* -----------------------------------------------------------------------</font>
<a name="line377">377: </a><font color="#B22222"> */</font>
<a name="line378">378: </a><font color="#B22222">/* ----- */</font>
<a name="line379">379: </a>    <font color="#B22222">/* Parameter adjustments */</font>
<a name="line380">380: </a>    --ind;
<a name="line381">381: </a>    --a;

<a name="line383">383: </a>    <font color="#B22222">/* Function Body */</font>
<a name="line384">384: </a>    first = 1;
<a name="line385">385: </a>    last = *n;
<a name="line386">386: </a>    <font color="#4169E1">if</font> (*ncut &lt; first || *ncut &gt; last) {
<a name="line387">387: </a>        <font color="#4169E1">return</font> 0;
<a name="line388">388: </a>    }

<a name="line390">390: </a><font color="#B22222">/*     outer loop -- while mid .ne. ncut do */</font>

<a name="line392">392: </a><strong><font color="#FF0000">L1:</font></strong>
<a name="line393">393: </a>    mid = first;
<a name="line394">394: </a>    abskey = (d__1 = a[mid],PetscAbsScalar(d__1));
<a name="line395">395: </a>    i__1 = last;
<a name="line396">396: </a>    <font color="#4169E1">for</font> (j = first + 1; j &lt;= i__1; ++j) {
<a name="line397">397: </a>        <font color="#4169E1">if</font> ((d__1 = a[j],PetscAbsScalar(d__1)) &gt; abskey) {
<a name="line398">398: </a>            ++mid;
<a name="line399">399: </a><font color="#B22222">/*     interchange */</font>
<a name="line400">400: </a>            tmp = a[mid];
<a name="line401">401: </a>            itmp = ind[mid];
<a name="line402">402: </a>            a[mid] = a[j];
<a name="line403">403: </a>            ind[mid] = ind[j];
<a name="line404">404: </a>            a[j] = tmp;
<a name="line405">405: </a>            ind[j] = itmp;
<a name="line406">406: </a>        }
<a name="line407">407: </a><font color="#B22222">/* L2: */</font>
<a name="line408">408: </a>    }

<a name="line410">410: </a><font color="#B22222">/*     interchange */</font>

<a name="line412">412: </a>    tmp = a[mid];
<a name="line413">413: </a>    a[mid] = a[first];
<a name="line414">414: </a>    a[first] = tmp;

<a name="line416">416: </a>    itmp = ind[mid];
<a name="line417">417: </a>    ind[mid] = ind[first];
<a name="line418">418: </a>    ind[first] = itmp;

<a name="line420">420: </a><font color="#B22222">/*     test for while loop */</font>

<a name="line422">422: </a>    <font color="#4169E1">if</font> (mid == *ncut) {
<a name="line423">423: </a>        <font color="#4169E1">return</font> 0;
<a name="line424">424: </a>    }
<a name="line425">425: </a>    <font color="#4169E1">if</font> (mid &gt; *ncut) {
<a name="line426">426: </a>        last = mid - 1;
<a name="line427">427: </a>    } <font color="#4169E1">else</font> {
<a name="line428">428: </a>        first = mid + 1;
<a name="line429">429: </a>    }
<a name="line430">430: </a>    <font color="#4169E1">goto</font> L1;
<a name="line431">431: </a><font color="#B22222">/* ----------------end-of-qsplit------------------------------------------</font>
<a name="line432">432: </a><font color="#B22222"> */</font>
<a name="line433">433: </a><font color="#B22222">/* -----------------------------------------------------------------------</font>
<a name="line434">434: </a><font color="#B22222"> */</font>
<a name="line435">435: </a>} <font color="#B22222">/* qsplit_ */</font>


<a name="line438">438: </a><font color="#B22222">/* ---------------------------------------------------------------------- */</font>
<a name="line439">439: </a><strong><font color="#4169E1"><a name="SPARSEKIT2ilutp"></a><A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> SPARSEKIT2ilutp(<A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A> *n,<A href="../../../../../docs/manualpages/Sys/PetscScalar.html#PetscScalar">PetscScalar</A> *a,<A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A> *ja,<A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A> * ia,<A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A> *lfil,<A href="../../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A> droptol,<A href="../../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A> *permtol,<A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A> *mbloc,<A href="../../../../../docs/manualpages/Sys/PetscScalar.html#PetscScalar">PetscScalar</A> *alu,</font></strong>
<a name="line440">440: </a><strong><font color="#4169E1">        <A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A> *jlu,<A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A> *ju,<A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A> *iwk,<A href="../../../../../docs/manualpages/Sys/PetscScalar.html#PetscScalar">PetscScalar</A> *w,<A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A> *jw,  <A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A> *iperm,<A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> *ierr)</font></strong>
<a name="line441">441: </a>{
<a name="line442">442: </a>    <font color="#B22222">/* System generated locals */</font>
<a name="line443">443: </a>    <A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A> i__1,i__2;
<a name="line444">444: </a>    <A href="../../../../../docs/manualpages/Sys/PetscScalar.html#PetscScalar">PetscScalar</A> d__1;

<a name="line446">446: </a>    <font color="#B22222">/* Local variables */</font>
<a name="line447">447: </a>    <A href="../../../../../docs/manualpages/Sys/PetscScalar.html#PetscScalar">PetscScalar</A> fact;
<a name="line448">448: </a>    <A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A> lenl,imax,lenu,icut,jpos;
<a name="line449">449: </a>    <A href="../../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A> xmax;
<a name="line450">450: </a>    <A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A> jrow;
<a name="line451">451: </a>    <A href="../../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A> xmax0;
<a name="line452">452: </a>    <A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A> i,j,k;
<a name="line453">453: </a>    <A href="../../../../../docs/manualpages/Sys/PetscScalar.html#PetscScalar">PetscScalar</A> s,t;
<a name="line454">454: </a>    <A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A> j_1,j2;
<a name="line455">455: </a>    <A href="../../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A> tnorm,t1;
<a name="line456">456: </a>    <A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A> ii,jj;
<a name="line457">457: </a>    <A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A> ju0,len;
<a name="line458">458: </a>    <A href="../../../../../docs/manualpages/Sys/PetscScalar.html#PetscScalar">PetscScalar</A> tmp;

<a name="line460">460: </a><font color="#B22222">/* -----------------------------------------------------------------------</font>
<a name="line461">461: </a><font color="#B22222"> */</font>
<a name="line462">462: </a><font color="#B22222">/*     implicit none */</font>
<a name="line463">463: </a><font color="#B22222">/* ----------------------------------------------------------------------*</font>
<a name="line464">464: </a><font color="#B22222"> */</font>
<a name="line465">465: </a><font color="#B22222">/*       *** ILUTP preconditioner -- ILUT with pivoting  ***            * </font>
<a name="line466">466: </a><font color="#B22222">*/</font>
<a name="line467">467: </a><font color="#B22222">/*      incomplete LU factorization with dual truncation mechanism      * </font>
<a name="line468">468: </a><font color="#B22222">*/</font>
<a name="line469">469: </a><font color="#B22222">/* ----------------------------------------------------------------------*</font>
<a name="line470">470: </a><font color="#B22222"> */</font>
<a name="line471">471: </a><font color="#B22222">/* author Yousef Saad *Sep 8, 1993 -- Latest revision, August 1996.     * </font>
<a name="line472">472: </a><font color="#B22222">*/</font>
<a name="line473">473: </a><font color="#B22222">/* ----------------------------------------------------------------------*</font>
<a name="line474">474: </a><font color="#B22222"> */</font>
<a name="line475">475: </a><font color="#B22222">/* on entry: */</font>
<a name="line476">476: </a><font color="#B22222">/* ========== */</font>
<a name="line477">477: </a><font color="#B22222">/* n       = integer. The dimension of the matrix A. */</font>

<a name="line479">479: </a><font color="#B22222">/* a,ja,ia = matrix stored in Compressed Sparse Row format. */</font>
<a name="line480">480: </a><font color="#B22222">/*           ON RETURN THE COLUMNS OF A ARE PERMUTED. SEE BELOW FOR */</font>
<a name="line481">481: </a><font color="#B22222">/*           DETAILS. */</font>

<a name="line483">483: </a><font color="#B22222">/* lfil    = integer. The fill-in parameter. Each row of L and each row */</font>

<a name="line485">485: </a><font color="#B22222">/*           of U will have a maximum of lfil elements (excluding the */</font>
<a name="line486">486: </a><font color="#B22222">/*           diagonal element). lfil must be .ge. 0. */</font>
<a name="line487">487: </a><font color="#B22222">/*           ** WARNING: THE MEANING OF LFIL HAS CHANGED WITH RESPECT TO </font>
<a name="line488">488: </a><font color="#B22222">*/</font>
<a name="line489">489: </a><font color="#B22222">/*           EARLIER VERSIONS. */</font>

<a name="line491">491: </a><font color="#B22222">/* droptol = real*8. Sets the threshold for dropping small terms in the */</font>

<a name="line493">493: </a><font color="#B22222">/*           factorization. See below for details on dropping strategy. */</font>


<a name="line496">496: </a><font color="#B22222">/* lfil    = integer. The fill-in parameter. Each row of L and */</font>
<a name="line497">497: </a><font color="#B22222">/*           each row of U will have a maximum of lfil elements. */</font>
<a name="line498">498: </a><font color="#B22222">/*           WARNING: THE MEANING OF LFIL HAS CHANGED WITH RESPECT TO */</font>
<a name="line499">499: </a><font color="#B22222">/*           EARLIER VERSIONS. */</font>
<a name="line500">500: </a><font color="#B22222">/*           lfil must be .ge. 0. */</font>

<a name="line502">502: </a><font color="#B22222">/* permtol = tolerance ratio used to  determne whether or not to permute </font>
<a name="line503">503: </a><font color="#B22222">*/</font>
<a name="line504">504: </a><font color="#B22222">/*           two columns.  At step i columns i and j are permuted when */</font>

<a name="line506">506: </a><font color="#B22222">/*                     abs(a(i,j))*permtol .gt. abs(a(i,i)) */</font>

<a name="line508">508: </a><font color="#B22222">/*           [0 --&gt; never permute; good values 0.1 to 0.01] */</font>

<a name="line510">510: </a><font color="#B22222">/* mbloc   = if desired, permuting can be done only within the diagonal */</font>

<a name="line512">512: </a><font color="#B22222">/*           blocks of <A href="../../../../../docs/manualpages/Sys/size.html#size">size</A> mbloc. Useful for PDE problems with several */</font>

<a name="line514">514: </a><font color="#B22222">/*           degrees of freedom.. If feature not wanted take mbloc=n. */</font>


<a name="line517">517: </a><font color="#B22222">/* iwk     = integer. The lengths of arrays alu and jlu. If the arrays */</font>
<a name="line518">518: </a><font color="#B22222">/*           are not big enough to store the ILU factorizations, ilut */</font>
<a name="line519">519: </a><font color="#B22222">/*           will stop with an error message. */</font>

<a name="line521">521: </a><font color="#B22222">/* On return: */</font>
<a name="line522">522: </a><font color="#B22222">/* =========== */</font>

<a name="line524">524: </a><font color="#B22222">/* alu,jlu = matrix stored in Modified Sparse Row (MSR) format containing </font>
<a name="line525">525: </a><font color="#B22222">*/</font>
<a name="line526">526: </a><font color="#B22222">/*           the L and U factors together. The diagonal (stored in */</font>
<a name="line527">527: </a><font color="#B22222">/*           alu(1:n)) is inverted. Each i-th row of the alu,jlu matrix </font>
<a name="line528">528: </a><font color="#B22222">*/</font>
<a name="line529">529: </a><font color="#B22222">/*           contains the i-th row of L (excluding the diagonal entry=1) </font>
<a name="line530">530: </a><font color="#B22222">*/</font>
<a name="line531">531: </a><font color="#B22222">/*           followed by the i-th row of U. */</font>

<a name="line533">533: </a><font color="#B22222">/* ju      = integer array of length n containing the pointers to */</font>
<a name="line534">534: </a><font color="#B22222">/*           the beginning of each row of U in the matrix alu,jlu. */</font>

<a name="line536">536: </a><font color="#B22222">/* iperm   = contains the permutation arrays. */</font>
<a name="line537">537: </a><font color="#B22222">/*           iperm(1:n) = old numbers of unknowns */</font>
<a name="line538">538: </a><font color="#B22222">/*           iperm(n+1:2*n) = reverse permutation = new unknowns. */</font>

<a name="line540">540: </a><font color="#B22222">/* integer. Error message with the following meaning. */</font>
<a name="line541">541: </a><font color="#B22222">/*           0    --&gt; successful return. */</font>
<a name="line542">542: </a><font color="#B22222">/*           ierr .gt. 0  --&gt; zero pivot encountered at step number ierr. </font>
<a name="line543">543: </a><font color="#B22222">*/</font>
<a name="line544">544: </a><font color="#B22222">/*           -1   --&gt; Error. input matrix may be wrong. */</font>
<a name="line545">545: </a><font color="#B22222">/*                            (The elimination process has generated a */</font>
<a name="line546">546: </a><font color="#B22222">/*                            row in L or U whose length is .gt.  n.) */</font>
<a name="line547">547: </a><font color="#B22222">/*           -2   --&gt; The matrix L overflows the array al. */</font>
<a name="line548">548: </a><font color="#B22222">/*           -3   --&gt; The matrix U overflows the array alu. */</font>
<a name="line549">549: </a><font color="#B22222">/*           -4   --&gt; Illegal value for lfil. */</font>
<a name="line550">550: </a><font color="#B22222">/*           -5   --&gt; zero row encountered. */</font>

<a name="line552">552: </a><font color="#B22222">/* work arrays: */</font>
<a name="line553">553: </a><font color="#B22222">/* ============= */</font>
<a name="line554">554: </a><font color="#B22222">/* jw      = integer work array of length 2*n. */</font>
<a name="line555">555: </a><font color="#B22222">/* w       = real work array of length n */</font>

<a name="line557">557: </a><font color="#B22222">/* IMPORTANR NOTE: */</font>
<a name="line558">558: </a><font color="#B22222">/* -------------- */</font>
<a name="line559">559: </a><font color="#B22222">/* TO AVOID PERMUTING THE SOLUTION VECTORS ARRAYS FOR EACH LU-SOLVE, */</font>
<a name="line560">560: </a><font color="#B22222">/* THE MATRIX A <A href="../../../../../docs/manualpages/IS/IS.html#IS">IS</A> PERMUTED ON RETURN. [all column indices are */</font>
<a name="line561">561: </a><font color="#B22222">/* changed]. SIMILARLY FOR THE U MATRIX. */</font>
<a name="line562">562: </a><font color="#B22222">/* To permute the matrix back to its original state use the loop: */</font>

<a name="line564">564: </a><font color="#B22222">/*      do k=ia(1), ia(n+1)-1 */</font>
<a name="line565">565: </a><font color="#B22222">/*         ja(k) = iperm(ja(k)) */</font>
<a name="line566">566: </a><font color="#B22222">/*      enddo */</font>

<a name="line568">568: </a><font color="#B22222">/* -----------------------------------------------------------------------</font>
<a name="line569">569: </a><font color="#B22222"> */</font>
<a name="line570">570: </a><font color="#B22222">/*     local variables */</font>


<a name="line573">573: </a>    <font color="#B22222">/* Parameter adjustments */</font>
<a name="line574">574: </a>    --iperm;
<a name="line575">575: </a>    --jw;
<a name="line576">576: </a>    --w;
<a name="line577">577: </a>    --ju;
<a name="line578">578: </a>    --jlu;
<a name="line579">579: </a>    --alu;
<a name="line580">580: </a>    --ia;
<a name="line581">581: </a>    --ja;
<a name="line582">582: </a>    --a;

<a name="line584">584: </a>    <font color="#B22222">/* Function Body */</font>
<a name="line585">585: </a>    <font color="#4169E1">if</font> (*lfil &lt; 0) {
<a name="line586">586: </a>        <font color="#4169E1">goto</font> L998;
<a name="line587">587: </a>    }
<a name="line588">588: </a><font color="#B22222">/* -----------------------------------------------------------------------</font>
<a name="line589">589: </a><font color="#B22222"> */</font>
<a name="line590">590: </a><font color="#B22222">/*     initialize ju0 (points to next element to be added to alu,jlu) */</font>
<a name="line591">591: </a><font color="#B22222">/*     and pointer array. */</font>
<a name="line592">592: </a><font color="#B22222">/* -----------------------------------------------------------------------</font>
<a name="line593">593: </a><font color="#B22222"> */</font>
<a name="line594">594: </a>    ju0 = *n + 2;
<a name="line595">595: </a>    jlu[1] = ju0;

<a name="line597">597: </a><font color="#B22222">/*  integer <A href="../../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A> pointer array. */</font>

<a name="line599">599: </a>    i__1 = *n;
<a name="line600">600: </a>    <font color="#4169E1">for</font> (j = 1; j &lt;= i__1; ++j) {
<a name="line601">601: </a>        jw[*n + j] = 0;
<a name="line602">602: </a>        iperm[j] = j;
<a name="line603">603: </a>        iperm[*n + j] = j;
<a name="line604">604: </a><font color="#B22222">/* L1: */</font>
<a name="line605">605: </a>    }
<a name="line606">606: </a><font color="#B22222">/* -----------------------------------------------------------------------</font>
<a name="line607">607: </a><font color="#B22222"> */</font>
<a name="line608">608: </a><font color="#B22222">/*     beginning of main loop. */</font>
<a name="line609">609: </a><font color="#B22222">/* -----------------------------------------------------------------------</font>
<a name="line610">610: </a><font color="#B22222"> */</font>
<a name="line611">611: </a>    i__1 = *n;
<a name="line612">612: </a>    <font color="#4169E1">for</font> (ii = 1; ii &lt;= i__1; ++ii) {
<a name="line613">613: </a>        j_1 = ia[ii];
<a name="line614">614: </a>        j2 = ia[ii + 1] - 1;
<a name="line615">615: </a>        tnorm = 0.;
<a name="line616">616: </a>        i__2 = j2;
<a name="line617">617: </a>        <font color="#4169E1">for</font> (k = j_1; k &lt;= i__2; ++k) {
<a name="line618">618: </a>            tnorm += (d__1 = a[k], PetscAbsScalar(d__1));
<a name="line619">619: </a><font color="#B22222">/* L501: */</font>
<a name="line620">620: </a>        }
<a name="line621">621: </a>        <font color="#4169E1">if</font> (!tnorm) {
<a name="line622">622: </a>            <font color="#4169E1">goto</font> L999;
<a name="line623">623: </a>        }
<a name="line624">624: </a>        tnorm /= j2 - j_1 + 1;

<a name="line626">626: </a><font color="#B22222">/*     unpack L-part and U-part of row of A in arrays  w  -- */</font>

<a name="line628">628: </a>        lenu = 1;
<a name="line629">629: </a>        lenl = 0;
<a name="line630">630: </a>        jw[ii] = ii;
<a name="line631">631: </a>        w[ii] = (float)0.;
<a name="line632">632: </a>        jw[*n + ii] = ii;

<a name="line634">634: </a>        i__2 = j2;
<a name="line635">635: </a>        <font color="#4169E1">for</font> (j = j_1; j &lt;= i__2; ++j) {
<a name="line636">636: </a>            k = iperm[*n + ja[j]];
<a name="line637">637: </a>            t = a[j];
<a name="line638">638: </a>            <font color="#4169E1">if</font> (k &lt; ii) {
<a name="line639">639: </a>                ++lenl;
<a name="line640">640: </a>                jw[lenl] = k;
<a name="line641">641: </a>                w[lenl] = t;
<a name="line642">642: </a>                jw[*n + k] = lenl;
<a name="line643">643: </a>            } <font color="#4169E1">else</font> <font color="#4169E1">if</font> (k == ii) {
<a name="line644">644: </a>                w[ii] = t;
<a name="line645">645: </a>            } <font color="#4169E1">else</font> {
<a name="line646">646: </a>                ++lenu;
<a name="line647">647: </a>                jpos = ii + lenu - 1;
<a name="line648">648: </a>                jw[jpos] = k;
<a name="line649">649: </a>                w[jpos] = t;
<a name="line650">650: </a>                jw[*n + k] = jpos;
<a name="line651">651: </a>            }
<a name="line652">652: </a><font color="#B22222">/* L170: */</font>
<a name="line653">653: </a>        }
<a name="line654">654: </a>        jj = 0;
<a name="line655">655: </a>        len = 0;

<a name="line657">657: </a><font color="#B22222">/*     eliminate previous rows */</font>

<a name="line659">659: </a><strong><font color="#FF0000">L150:</font></strong>
<a name="line660">660: </a>        ++jj;
<a name="line661">661: </a>        <font color="#4169E1">if</font> (jj &gt; lenl) {
<a name="line662">662: </a>            <font color="#4169E1">goto</font> L160;
<a name="line663">663: </a>        }
<a name="line664">664: </a><font color="#B22222">/* ------------------------------------------------------------------</font>
<a name="line665">665: </a><font color="#B22222">----- */</font>
<a name="line666">666: </a><font color="#B22222">/*     in order to do the elimination in the correct order we must sel</font>
<a name="line667">667: </a><font color="#B22222">ect */</font>
<a name="line668">668: </a><font color="#B22222">/*     the smallest column index among jw(k), k=jj+1, ..., lenl. */</font>
<a name="line669">669: </a><font color="#B22222">/* ------------------------------------------------------------------</font>
<a name="line670">670: </a><font color="#B22222">----- */</font>
<a name="line671">671: </a>        jrow = jw[jj];
<a name="line672">672: </a>        k = jj;

<a name="line674">674: </a><font color="#B22222">/*     determine smallest column index */</font>

<a name="line676">676: </a>        i__2 = lenl;
<a name="line677">677: </a>        <font color="#4169E1">for</font> (j = jj + 1; j &lt;= i__2; ++j) {
<a name="line678">678: </a>            <font color="#4169E1">if</font> (jw[j] &lt; jrow) {
<a name="line679">679: </a>                jrow = jw[j];
<a name="line680">680: </a>                k = j;
<a name="line681">681: </a>            }
<a name="line682">682: </a><font color="#B22222">/* L151: */</font>
<a name="line683">683: </a>        }

<a name="line685">685: </a>        <font color="#4169E1">if</font> (k != jj) {
<a name="line686">686: </a><font color="#B22222">/*     exchange in jw */</font>
<a name="line687">687: </a>            j = jw[jj];
<a name="line688">688: </a>            jw[jj] = jw[k];
<a name="line689">689: </a>            jw[k] = j;
<a name="line690">690: </a><font color="#B22222">/*     exchange in jr */</font>
<a name="line691">691: </a>            jw[*n + jrow] = jj;
<a name="line692">692: </a>            jw[*n + j] = k;
<a name="line693">693: </a><font color="#B22222">/*     exchange in w */</font>
<a name="line694">694: </a>            s = w[jj];
<a name="line695">695: </a>            w[jj] = w[k];
<a name="line696">696: </a>            w[k] = s;
<a name="line697">697: </a>        }

<a name="line699">699: </a><font color="#B22222">/*     zero out element in row by resetting jw(n+jrow) to zero. */</font>

<a name="line701">701: </a>        jw[*n + jrow] = 0;

<a name="line703">703: </a><font color="#B22222">/*     get the multiplier for row to be eliminated: jrow */</font>

<a name="line705">705: </a>        fact = w[jj] * alu[jrow];

<a name="line707">707: </a><font color="#B22222">/*     drop term if small */</font>

<a name="line709">709: </a>        <font color="#4169E1">if</font> (PetscAbsScalar(fact) &lt;= droptol) {
<a name="line710">710: </a>            <font color="#4169E1">goto</font> L150;
<a name="line711">711: </a>        }

<a name="line713">713: </a><font color="#B22222">/*     combine current row and row jrow */</font>

<a name="line715">715: </a>        i__2 = jlu[jrow + 1] - 1;
<a name="line716">716: </a>        <font color="#4169E1">for</font> (k = ju[jrow]; k &lt;= i__2; ++k) {
<a name="line717">717: </a>            s = fact * alu[k];
<a name="line718">718: </a><font color="#B22222">/*     new column number */</font>
<a name="line719">719: </a>            j = iperm[*n + jlu[k]];
<a name="line720">720: </a>            jpos = jw[*n + j];
<a name="line721">721: </a>            <font color="#4169E1">if</font> (j &gt;= ii) {

<a name="line723">723: </a><font color="#B22222">/*     dealing with upper part. */</font>

<a name="line725">725: </a>                <font color="#4169E1">if</font> (!jpos) {

<a name="line727">727: </a><font color="#B22222">/*     this is a fill-in element */</font>

<a name="line729">729: </a>                    ++lenu;
<a name="line730">730: </a>                    i = ii + lenu - 1;
<a name="line731">731: </a>                    <font color="#4169E1">if</font> (lenu &gt; *n) {
<a name="line732">732: </a>                        <font color="#4169E1">goto</font> L995;
<a name="line733">733: </a>                    }
<a name="line734">734: </a>                    jw[i] = j;
<a name="line735">735: </a>                    jw[*n + j] = i;
<a name="line736">736: </a>                    w[i] = -s;
<a name="line737">737: </a>                } <font color="#4169E1">else</font> {
<a name="line738">738: </a><font color="#B22222">/*     no fill-in element -- */</font>
<a name="line739">739: </a>                    w[jpos] -= s;
<a name="line740">740: </a>                }
<a name="line741">741: </a>            } <font color="#4169E1">else</font> {

<a name="line743">743: </a><font color="#B22222">/*     dealing with lower part. */</font>

<a name="line745">745: </a>                <font color="#4169E1">if</font> (!jpos) {

<a name="line747">747: </a><font color="#B22222">/*     this is a fill-in element */</font>

<a name="line749">749: </a>                    ++lenl;
<a name="line750">750: </a>                    <font color="#4169E1">if</font> (lenl &gt; *n) {
<a name="line751">751: </a>                        <font color="#4169E1">goto</font> L995;
<a name="line752">752: </a>                    }
<a name="line753">753: </a>                    jw[lenl] = j;
<a name="line754">754: </a>                    jw[*n + j] = lenl;
<a name="line755">755: </a>                    w[lenl] = -s;
<a name="line756">756: </a>                } <font color="#4169E1">else</font> {

<a name="line758">758: </a><font color="#B22222">/*     this is not a fill-in element */</font>

<a name="line760">760: </a>                    w[jpos] -= s;
<a name="line761">761: </a>                }
<a name="line762">762: </a>            }
<a name="line763">763: </a><font color="#B22222">/* L203: */</font>
<a name="line764">764: </a>        }

<a name="line766">766: </a><font color="#B22222">/*     store this pivot element -- (from left to right -- no danger of</font>
<a name="line767">767: </a><font color="#B22222"> */</font>
<a name="line768">768: </a><font color="#B22222">/*     overlap with the working elements in L (pivots). */</font>

<a name="line770">770: </a>        ++len;
<a name="line771">771: </a>        w[len] = fact;
<a name="line772">772: </a>        jw[len] = jrow;
<a name="line773">773: </a>        <font color="#4169E1">goto</font> L150;
<a name="line774">774: </a><strong><font color="#FF0000">L160:</font></strong>

<a name="line776">776: </a><font color="#B22222">/*     reset double-pointer to zero (U-part) */</font>

<a name="line778">778: </a>        i__2 = lenu;
<a name="line779">779: </a>        <font color="#4169E1">for</font> (k = 1; k &lt;= i__2; ++k) {
<a name="line780">780: </a>            jw[*n + jw[ii + k - 1]] = 0;
<a name="line781">781: </a><font color="#B22222">/* L308: */</font>
<a name="line782">782: </a>        }

<a name="line784">784: </a><font color="#B22222">/*     update L-matrix */</font>

<a name="line786">786: </a>        lenl = len;
<a name="line787">787: </a>        len = <A href="../../../../../docs/manualpages/Sys/PetscMin.html#PetscMin">PetscMin</A>(lenl,*lfil);

<a name="line789">789: </a><font color="#B22222">/*     sort by quick-split */</font>

<a name="line791">791: </a>        SPARSEKIT2qsplit(&amp;w[1], &amp;jw[1], &amp;lenl, &amp;len);

<a name="line793">793: </a><font color="#B22222">/*     store L-part -- in original coordinates .. */</font>

<a name="line795">795: </a>        i__2 = len;
<a name="line796">796: </a>        <font color="#4169E1">for</font> (k = 1; k &lt;= i__2; ++k) {
<a name="line797">797: </a>            <font color="#4169E1">if</font> (ju0 &gt; *iwk) {
<a name="line798">798: </a>                <font color="#4169E1">goto</font> L996;
<a name="line799">799: </a>            }
<a name="line800">800: </a>            alu[ju0] = w[k];
<a name="line801">801: </a>            jlu[ju0] = iperm[jw[k]];
<a name="line802">802: </a>            ++ju0;
<a name="line803">803: </a><font color="#B22222">/* L204: */</font>
<a name="line804">804: </a>        }

<a name="line806">806: </a><font color="#B22222">/*     save pointer to beginning of row ii of U */</font>

<a name="line808">808: </a>        ju[ii] = ju0;

<a name="line810">810: </a><font color="#B22222">/*     update U-matrix -- first apply dropping strategy */</font>

<a name="line812">812: </a>        len = 0;
<a name="line813">813: </a>        i__2 = lenu - 1;
<a name="line814">814: </a>        <font color="#4169E1">for</font> (k = 1; k &lt;= i__2; ++k) {
<a name="line815">815: </a>            <font color="#4169E1">if</font> ((d__1 = w[ii + k], PetscAbsScalar(d__1)) &gt; droptol * tnorm) {
<a name="line816">816: </a>                ++len;
<a name="line817">817: </a>                w[ii + len] = w[ii + k];
<a name="line818">818: </a>                jw[ii + len] = jw[ii + k];
<a name="line819">819: </a>            }
<a name="line820">820: </a>        }
<a name="line821">821: </a>        lenu = len + 1;
<a name="line822">822: </a>        len = <A href="../../../../../docs/manualpages/Sys/PetscMin.html#PetscMin">PetscMin</A>(lenu,*lfil);
<a name="line823">823: </a>        i__2 = lenu - 1;
<a name="line824">824: </a>        SPARSEKIT2qsplit(&amp;w[ii + 1], &amp;jw[ii + 1], &amp;i__2, &amp;len);

<a name="line826">826: </a><font color="#B22222">/*     determine next pivot -- */</font>

<a name="line828">828: </a>        imax = ii;
<a name="line829">829: </a>        xmax = (d__1 = w[imax], PetscAbsScalar(d__1));
<a name="line830">830: </a>        xmax0 = xmax;
<a name="line831">831: </a>        icut = ii - 1 + *mbloc - (ii - 1) % *mbloc;
<a name="line832">832: </a>        i__2 = ii + len - 1;
<a name="line833">833: </a>        <font color="#4169E1">for</font> (k = ii + 1; k &lt;= i__2; ++k) {
<a name="line834">834: </a>            t1 = (d__1 = w[k], PetscAbsScalar(d__1));
<a name="line835">835: </a>            <font color="#4169E1">if</font> (t1 &gt; xmax &amp;&amp; t1 * *permtol &gt; xmax0 &amp;&amp; jw[k] &lt;= icut) {
<a name="line836">836: </a>                imax = k;
<a name="line837">837: </a>                xmax = t1;
<a name="line838">838: </a>            }
<a name="line839">839: </a>        }

<a name="line841">841: </a><font color="#B22222">/*     exchange w's */</font>

<a name="line843">843: </a>        tmp = w[ii];
<a name="line844">844: </a>        w[ii] = w[imax];
<a name="line845">845: </a>        w[imax] = tmp;

<a name="line847">847: </a><font color="#B22222">/*     update iperm and reverse iperm */</font>

<a name="line849">849: </a>        j = jw[imax];
<a name="line850">850: </a>        i = iperm[ii];
<a name="line851">851: </a>        iperm[ii] = iperm[j];
<a name="line852">852: </a>        iperm[j] = i;

<a name="line854">854: </a><font color="#B22222">/*     reverse iperm */</font>

<a name="line856">856: </a>        iperm[*n + iperm[ii]] = ii;
<a name="line857">857: </a>        iperm[*n + iperm[j]] = j;
<a name="line858">858: </a><font color="#B22222">/* ------------------------------------------------------------------</font>
<a name="line859">859: </a><font color="#B22222">----- */</font>

<a name="line861">861: </a>        <font color="#4169E1">if</font> (len + ju0 &gt; *iwk) {
<a name="line862">862: </a>            <font color="#4169E1">goto</font> L997;
<a name="line863">863: </a>        }

<a name="line865">865: </a><font color="#B22222">/*     copy U-part in original coordinates */</font>

<a name="line867">867: </a>        i__2 = ii + len - 1;
<a name="line868">868: </a>        <font color="#4169E1">for</font> (k = ii + 1; k &lt;= i__2; ++k) {
<a name="line869">869: </a>            jlu[ju0] = iperm[jw[k]];
<a name="line870">870: </a>            alu[ju0] = w[k];
<a name="line871">871: </a>            ++ju0;
<a name="line872">872: </a><font color="#B22222">/* L302: */</font>
<a name="line873">873: </a>        }

<a name="line875">875: </a><font color="#B22222">/*     store inverse of diagonal element of u */</font>

<a name="line877">877: </a>        <font color="#4169E1">if</font> (w[ii] == 0.0) {
<a name="line878">878: </a>            w[ii] = (droptol + 1e-4) * tnorm;
<a name="line879">879: </a>        }
<a name="line880">880: </a>        alu[ii] = 1. / w[ii];

<a name="line882">882: </a><font color="#B22222">/*     update pointer to beginning of next row of U. */</font>

<a name="line884">884: </a>        jlu[ii + 1] = ju0;
<a name="line885">885: </a><font color="#B22222">/* ------------------------------------------------------------------</font>
<a name="line886">886: </a><font color="#B22222">----- */</font>
<a name="line887">887: </a><font color="#B22222">/*     end main loop */</font>
<a name="line888">888: </a><font color="#B22222">/* ------------------------------------------------------------------</font>
<a name="line889">889: </a><font color="#B22222">----- */</font>
<a name="line890">890: </a><font color="#B22222">/* L500: */</font>
<a name="line891">891: </a>    }

<a name="line893">893: </a><font color="#B22222">/*     permute all column indices of LU ... */</font>

<a name="line895">895: </a>    i__1 = jlu[*n + 1] - 1;
<a name="line896">896: </a>    <font color="#4169E1">for</font> (k = jlu[1]; k &lt;= i__1; ++k) {
<a name="line897">897: </a>        jlu[k] = iperm[*n + jlu[k]];
<a name="line898">898: </a>    }

<a name="line900">900: </a><font color="#B22222">/*     ...and of A */</font>

<a name="line902">902: </a>    i__1 = ia[*n + 1] - 1;
<a name="line903">903: </a>    <font color="#4169E1">for</font> (k = ia[1]; k &lt;= i__1; ++k) {
<a name="line904">904: </a>        ja[k] = iperm[*n + ja[k]];
<a name="line905">905: </a>    }

<a name="line907">907: </a>    *0;
<a name="line908">908: </a>    <font color="#4169E1">return</font> 0;

<a name="line910">910: </a><font color="#B22222">/*     incomprehensible error. Matrix must be wrong. */</font>

<a name="line912">912: </a><strong><font color="#FF0000">L995:</font></strong>
<a name="line913">913: </a>    *-1;
<a name="line914">914: </a>    <font color="#4169E1">return</font> 0;

<a name="line916">916: </a><font color="#B22222">/*     insufficient storage in L. */</font>

<a name="line918">918: </a><strong><font color="#FF0000">L996:</font></strong>
<a name="line919">919: </a>    *-2;
<a name="line920">920: </a>    <font color="#4169E1">return</font> 0;

<a name="line922">922: </a><font color="#B22222">/*     insufficient storage in U. */</font>

<a name="line924">924: </a><strong><font color="#FF0000">L997:</font></strong>
<a name="line925">925: </a>    *-3;
<a name="line926">926: </a>    <font color="#4169E1">return</font> 0;

<a name="line928">928: </a><font color="#B22222">/*     illegal lfil entered. */</font>

<a name="line930">930: </a><strong><font color="#FF0000">L998:</font></strong>
<a name="line931">931: </a>    *-4;
<a name="line932">932: </a>    <font color="#4169E1">return</font> 0;

<a name="line934">934: </a><font color="#B22222">/*     zero row encountered */</font>

<a name="line936">936: </a><strong><font color="#FF0000">L999:</font></strong>
<a name="line937">937: </a>    *-5;
<a name="line938">938: </a>    <font color="#4169E1">return</font> 0;
<a name="line939">939: </a><font color="#B22222">/* ----------------end-of-ilutp-------------------------------------------</font>
<a name="line940">940: </a><font color="#B22222"> */</font>
<a name="line941">941: </a><font color="#B22222">/* -----------------------------------------------------------------------</font>
<a name="line942">942: </a><font color="#B22222"> */</font>
<a name="line943">943: </a>} <font color="#B22222">/* ilutp_ */</font>
<a name="line944">944: </a><font color="#A020F0">#endif</font>

</pre>
</body>

</html>
